/*
 * NIOS FFT Audio
 *
 * This example calculates the dominante frequency of an Audiostream. It runs on
 * the Nios II 'standard', 'full_featured', 'fast', and 'low_cost' example
 * designs. It runs with or without the MicroC/OS-II RTOS and requires a STDOUT
 * device in your system's hardware.
 *
 * The Qsys System design needs to have an Audio-configdevice in order to work right.
 *
 */
//Autor: Lukas Whle Version 2.1 (08.02.2017)




/*****************************************************/
#define samples 1024;     // Number of Samples for FFT
/*****************************************************/


#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "system.h"
#include "altera_avalon_pio_regs.h"
#include "altera_up_avalon_audio.h"
#include "altera_up_avalon_audio_and_video_config.h"
#include "AUDIO_CODEC_REGISTER_CONFIG.h"
#include "FFT_Matlab.h"
#include "altera_up_avalon_character_lcd.h"



// open the Character LCD port






int main(void)
{	int Samples=samples;	// Samples
	int count=0xFF;			// Counter var for LEDs
	int CNT_Start=0;		// Var to hold State (Start/Stop)
	int x=1;				// Break var for while loop
	int i=0;				// Samplecount
	char buf[40];




	alt_up_character_lcd_dev * char_lcd_dev;
	alt_up_av_config_dev* Audio_conf;	//Opens the Audio/Video Configuration device specified by name .
	alt_up_audio_dev * audio_dev;		//Opens the Audio device


	signed int Buff_R[1024]={0};		// Buffer for Audiosamples
	double Buff_R_doub[1024]={0};		// Conversion Buffer (signed to double)
	double Dominante;					// Output Var for dominant Frequency

	// open the config Port

	Audio_conf = alt_up_av_config_open_dev("/dev/audio_and_video_config_0");
	char_lcd_dev = alt_up_character_lcd_open_dev ("/dev/character_lcd_0");

	// Configure Audio-Codec - see documentation and AUDIO_CODEC_REGISTER_CONFIG.h
	alt_up_av_config_write_audio_cfg_register(Audio_conf, REG_00 ,REG_00_DEFAULT);
	alt_up_av_config_write_audio_cfg_register(Audio_conf, REG_01 ,REG_01_DEFAULT);
	alt_up_av_config_write_audio_cfg_register(Audio_conf, REG_02 ,REG_02_DEFAULT);
	alt_up_av_config_write_audio_cfg_register(Audio_conf, REG_03 ,REG_03_DEFAULT);
	alt_up_av_config_write_audio_cfg_register(Audio_conf, REG_04 ,REG_04_DEFAULT);
	alt_up_av_config_write_audio_cfg_register(Audio_conf, REG_05 ,REG_05_DEFAULT);
	alt_up_av_config_write_audio_cfg_register(Audio_conf, REG_06 ,REG_06_DEFAULT);
	alt_up_av_config_write_audio_cfg_register(Audio_conf, REG_07 ,REG_07_DEFAULT);
	alt_up_av_config_write_audio_cfg_register(Audio_conf, REG_08 ,REG_08_DEFAULT);
	alt_up_av_config_write_audio_cfg_register(Audio_conf, REG_09 ,REG_09_DEFAULT);

	// open the Audio port
	audio_dev = alt_up_audio_open_dev ("/dev/audio_0");

	// catch exception when Device is not present
	if ( audio_dev == NULL)
	 printf ("Error: could not open audio device \n");
	else
	 printf ("Opened audio device \n");

	if ( char_lcd_dev == NULL)
		alt_printf ("Error: could not open character LCD device\n");
	else
		alt_printf ("Opened character LCD device\n");
	/* Initialize the character display */
	alt_up_character_lcd_init (char_lcd_dev);
	/* Write "Welcome to" in the first row */
	alt_up_character_lcd_string(char_lcd_dev, "Fuck");


	// Debug print
	printf("Start Loopback with 1, end with 0");


	// Start Counter (7-segment) and Turn off/on LEDs
	IOWR_ALTERA_AVALON_PIO_DATA(PIO_LED_BASE,count & 0xFF);
				  scanf("%i",&CNT_Start);
				  printf("%i",CNT_Start);
				  switch (CNT_Start){
				  case 0:
					  IOWR_ALTERA_AVALON_PIO_DATA(CNT_EN_BASE, 0x00);
					  IOWR_ALTERA_AVALON_PIO_DATA(PIO_LED_BASE,0xFF);
					  break;
				  case 1:
					  IOWR_ALTERA_AVALON_PIO_DATA(CNT_EN_BASE, 0x01);
					  IOWR_ALTERA_AVALON_PIO_DATA(PIO_LED_BASE,0x00);
					  break;
				  default:
					  printf("nutin");
				  }
	while(x==1)
	{
		// Read Audio Data, check if samples are available
		int fifospace = alt_up_audio_read_fifo_avail (audio_dev, ALT_UP_AUDIO_LEFT);
		if ( fifospace != 0 ) 	// check if data is available
	{
		if (i==Samples){		// if Samples == 1024, Start FFT
			printf("success");	// Debug print
/*************************************************************************
				Convert unsigned integer to double
Codec values are only positve, Starting one (sign) is not recognized
				as signed - > needs to be converted
*************************************************************************/
			for(int a=0;a<=Samples;a++){
				if (Buff_R[a] & (1<<23)) {
				  Buff_R[a]|= (1<<31)|(1<<30)|(1<<29)|(1<<28)|(1<<27)|(1<<26)|(1<<25)|(1<<24);
				  Buff_R_doub[a]=(double)Buff_R[a];
				}
				else{
				   Buff_R_doub[a]=(double)Buff_R[a];
				}
			}
			i=0;	// Set FFT-Counter var to zero
			Dominante= FFT_Matlab(Buff_R_doub); // Calculate dominante frequency
			printf("Frequenzcy is: ");			// print frequency
			printf("%f",Dominante);
			sprintf(buf, "%f", Dominante);
			alt_up_character_lcd_string(char_lcd_dev, buf);
			alt_up_character_lcd_set_cursor_pos(char_lcd_dev, 0, 1);
			alt_up_character_lcd_string(char_lcd_dev, "Fuck");
			printf("\n");
		}
		// Read Audio Buffer data and save to Buffer
		alt_up_audio_read_fifo (audio_dev, &(Buff_R[i]), 1, ALT_UP_AUDIO_LEFT);
		// increment Counter
		i++;
	}

}

}

